function [NewModel]=ExplainedVariance(OldModel)
% Coded by Ezequiel Lpez-Rubio, April 2012.
% Apply the explained variance method

NewModel=OldModel;

for NdxGaussian=1:length(NewModel.Covariances)
    [EigenVectors,EigenValues]=eig(NewModel.Covariances{NdxGaussian});
    % Sort the eigenvalues in descending order
    [SortedEigenValues,AutoInd]=sort(diag(EigenValues));
    SortedEigenValues=flipud(SortedEigenValues);
    AutoInd=flipud(AutoInd);
    % Find the number of principal directions needed
    NewModel.NumPrincipalDirections{NdxGaussian}=1;
    AccumulatedVariance=SortedEigenValues(1);
    GoalVariance=sum(SortedEigenValues)*NewModel.VarianceAmount;
    while AccumulatedVariance<GoalVariance
        NewModel.NumPrincipalDirections{NdxGaussian}=NewModel.NumPrincipalDirections{NdxGaussian}+1;
        AccumulatedVariance=AccumulatedVariance+SortedEigenValues(NewModel.NumPrincipalDirections{NdxGaussian});
    end
    % Store eigenvalues, eigenvectors and residual variance
    SortedEigenVectors=EigenVectors(:,AutoInd);
    NewModel.EigenVectors{NdxGaussian}=SortedEigenVectors(:,1:NewModel.NumPrincipalDirections{NdxGaussian});
    NewModel.EigenValues{NdxGaussian}=SortedEigenValues(1:NewModel.NumPrincipalDirections{NdxGaussian});
    NewModel.Sigma2{NdxGaussian}=NewModel.GammaParameter*min(NewModel.EigenValues{NdxGaussian});
end    