function [Model]=PreTrainSmoothParzenWindows(Samples,VarianceAmount,NumNeighbors,GammaParameter)
% Coded by Ezequiel Lpez-Rubio, April 2012.
% Compute the non smoothed model
% Inputs:
%   Samples=Matrix where each column is an input sample

Model.NumNeighbors=NumNeighbors;
Model.Samples=Samples;
Model.GammaParameter=GammaParameter;
Model.VarianceAmount=VarianceAmount;

% Create a matrix with the Euclidean distances among all input samples
Distances=distanceMEX(Samples, Samples);
[Dist,Indices] = sort(Distances);

for NdxSample=1:size(Samples,2)
    % Find the nearest neighbors of this sample
    NeighborSamples=Samples(:,Indices(1:(NumNeighbors+1),NdxSample));
    % Prepare for PCA
    Model.Means{NdxSample}=mean(NeighborSamples,2);
    Model.Covariances{NdxSample}=cov(NeighborSamples');
end

% Apply the explained variance method
Model=ExplainedVariance(Model);
